Index: /trunk/gli/src/org/greenstone/gatherer/gui/EnrichPane.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gui/EnrichPane.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/gui/EnrichPane.java	(revision 8313)
@@ -37,4 +37,5 @@
 package org.greenstone.gatherer.gui;
 
+
 import java.awt.*;
 import java.awt.event.*;
@@ -42,5 +43,4 @@
 import java.util.*;
 import javax.swing.*;
-import javax.swing.border.*;
 import javax.swing.event.*;
 import javax.swing.table.*;
@@ -51,26 +51,23 @@
 import org.greenstone.gatherer.Gatherer;
 import org.greenstone.gatherer.file.FileNode;
-import org.greenstone.gatherer.gui.table.GTableModel;
-import org.greenstone.gatherer.gui.table.TableCellRenderer;
 import org.greenstone.gatherer.gui.tree.DragTree;
-import org.greenstone.gatherer.msm.ElementWrapper;
-import org.greenstone.gatherer.msm.Metadata;
-import org.greenstone.gatherer.msm.MSMEvent;
-import org.greenstone.gatherer.msm.MSMListener;
-import org.greenstone.gatherer.util.Codec;
+import org.greenstone.gatherer.metadata.MetadataElement;
+import org.greenstone.gatherer.metadata.MetadataValue;
+import org.greenstone.gatherer.metadata.MetadataValueTableEntry;
+import org.greenstone.gatherer.metadata.MetadataValueTableModel;
+import org.greenstone.gatherer.metadata.MetadataValueTreeModel;
+import org.greenstone.gatherer.metadata.MetadataValueTreeNode;
+import org.greenstone.gatherer.metadata.MetadataXMLFileManager;
 import org.greenstone.gatherer.util.DragGroup;
 import org.greenstone.gatherer.util.PatternTokenizer;
-import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.TreeSynchronizer;
 import org.greenstone.gatherer.util.Utility;
-import org.greenstone.gatherer.valuetree.GValueModel;
-import org.greenstone.gatherer.valuetree.GValueNode;
-/** Provides a view of controls for the editing of metadata. It makes use of several other important components such as a GTree, GTable and GValueTree. While much of the gui content is left to these components, the EnrichPane is resposible for actioning metadata edit requests, listing for mouse clicks within its scope and other data functionality (such as providing a list of the selected files).
-* @author John Thompson, Greenstone Digital Libraries, University of Waikato
-* @version 2.3b
-*/
+
+
+/** Provides a view of controls for the editing of metadata. It makes use of several other important components such as a GTree, GTable and MetadataValueTree. While much of the gui content is left to these components, the EnrichPane is resposible for actioning metadata edit requests, listing for mouse clicks within its scope and other data functionality (such as providing a list of the selected files).
+ */
 public class EnrichPane
     extends JPanel
-    implements ActionListener, ListSelectionListener, TreeSelectionListener, MSMListener {
+    implements ActionListener, TreeSelectionListener {
 
     static private Dimension BUTTON_SIZE = new Dimension(190, 25);
@@ -80,27 +77,28 @@
     static private Dimension TREE_SIZE = new Dimension(250, 500);
     static private int MINIMUM_TABLE_HEADER_SIZE = 15;
-    /** The name of the panel containing the metadata table. */
-    static final private String CARD_ONE  = "Card One";
-    /** The name of the panel containing the 'no file' placeholder for the metadata table. */
-    static final private String CARD_TWO = "Card Two";
-    /** The name of the panel containing the 'no metadata' placeholder for the metadata table. */
-    static final private String CARD_ZERO = "Card Zero";
-    /** The name of the panel containing the placeholder for the value tree. */
-    static final private String TOOLS_OFF = "Tools Off";
-    /** The name of the panel containing the value tree. */
-    static final private String TOOLS_ON  = "Tools On";
-
-    /** The GValueTree graphically shows the available metadata that has been previously assigned, and provides controls for adding, updating and removing metadata, depending on the users selections in the other important components. */
-    private GValueTree tree = null;
-    /** The layout manager used to display either the GTable (when records are selected) or a placeholder panel with the immortal words 'No Record Selected'. */
-    private CardLayout card_layout = null;
-    /** The layout manager used to display either the GValueTree (when records are selected) or a placeholder panel with the immortal words 'No Record Selected'. */
-    private CardLayout card_layout2 = null;
+
+    private MetadataValueTable metadata_value_table = null;
+    /** The layout manager used to display either the MetadataValueTable (when files are selected) or a placeholder panel */
+    private CardLayout metadata_value_table_card_layout = null;
+    /** The name of the panel containing the metadata table */
+    static final private String TABLE_CARD = "";
+    /** The name of the panel containing the "no files selected" placeholder for the metadata table */
+    static final private String TABLE_CARD_NO_FILES_SELECTED = "No files selected";
+    /** The name of the panel containing the "no metadata available" placeholder for the metadata table */
+    static final private String TABLE_CARD_NO_METADATA_AVAILABLE = "No metadata available";
+
+    /** The MetadataValueTree graphically shows the available metadata that has been previously assigned, and provides controls for adding, updating and removing metadata, depending on the user's selections in the other important components. */
+    private MetadataValueTree metadata_value_tree = null;
+    /** The layout manager used to display either the MetadataValueTree (when metadata is selected) or a placeholder panel */
+    private CardLayout metadata_value_tree_card_layout = null;
+    /** The name of the panel containing the metadata value tree */
+    static final private String TREE_CARD = "";
+    /** The name of the panel containing the "no metadata element selected" placeholder for the metadata table */
+    static final private String TREE_CARD_NO_METADATA_ELEMENT_SELECTED  = "No metadata element selected";
+
     /** Used to dynamically filter the collection tree at user request. Note that this is synchronized with the collection tree filter in the Gather view. */
     private Filter filter = null;
-    /** The data model behind the GTable, to which we hold a reference for convenient access. */
-    private GTableModel model = null;
-    /** The currently reported selection. Note that this may actually be incorrect, but if so the changed flag will be set, and the selection will be updated the next time it is needed. */
-    private FileNode records[] = null;
+    /** The currently reported selection. */
+    private FileNode[] file_nodes = null;
     /** The button, which when clicked, adds metadata to the selected records. */
     private JButton add;
@@ -120,23 +118,18 @@
     /** The splitpane dividing the collection tree and the metadata based controls. */
     private JSplitPane external_split;
-    /** A reference to the metadata table, via its superclass. */
-    private JTable table;
     /** The label shown at the top of the metadata table detailing the current selection statistics. */
     private JTextField table_label;
     /** A reference to the collection tree. */
     private DragTree collection_tree;
-    /** The currently selected metadata determined by listening to every second list selection event from the metadata table. */
-    private Metadata selected_metadata;
     /** Provide synchronization between the collection trees in this view and the collection pane view. */
     private TreeSynchronizer tree_sync = null;
+    private boolean metadata_edit_event = false;
+
 
     /** Constructor.
      * @param tree_sync The <strong>TreeSynchronizer</strong> to be used on the collection tree
-     * @see org.greenstone.gatherer.Configuration
-     * @see org.greenstone.gatherer.gui.EnrichPane.GValueTree
      */
     public EnrichPane(TreeSynchronizer tree_sync)
     {
-	this.tree = null;
 	this.tree_sync = tree_sync;
 
@@ -176,5 +169,6 @@
 	Dictionary.registerBoth(expand_for_extracted, "MetaEdit.Expand", "MetaEdit.Expand_Tooltip");
 
-	tree = new GValueTree(CONTROL_SIZE.width, CONTROL_SIZE.height);
+	metadata_value_table = new MetadataValueTable();
+	metadata_value_tree = new MetadataValueTree(CONTROL_SIZE.width, CONTROL_SIZE.height);
     }
 
@@ -182,129 +176,58 @@
     /** Called whenever an action occurs on one of our registered buttons.
      * @param event An <strong>ActionEvent</strong> containing information about the event.
-     * @see org.greenstone.gatherer.collection.CollectionManager
-     * @see org.greenstone.gatherer.gui.EnrichPane.GValueTree
-     * @see org.greenstone.gatherer.gui.table.GTableModel
-     * @see org.greenstone.gatherer.msm.ElementWrapper
-     * @see org.greenstone.gatherer.msm.MetadataSetManager
-     * @see org.greenstone.gatherer.msm.MSMEvent
      */
-    public void actionPerformed(ActionEvent event) {
+    public void actionPerformed(ActionEvent event)
+    {
 	Object esrc = event.getSource();
+
+	// Add button pressed
 	if (esrc == add) {
-	    ElementWrapper element = tree.getSelectedMetadataElement();
-	    String value = tree.getSelectedValue();
-	    (new AppendMetadataTask(element, value)).start();
-	    value = null;
-	    element = null;
-	}
+	    MetadataElement metadata_element = metadata_value_table.getSelectedMetadataElement();
+	    MetadataValueTreeNode metadata_value_tree_node = metadata_element.addMetadataValue(metadata_value_tree.getSelectedValue());
+	    MetadataValue metadata_value = new MetadataValue(metadata_element, metadata_value_tree_node);
+	    metadata_value.setIsAccumulatingMetadata(true);
+	    (new AppendMetadataTask(metadata_value)).start();
+	}
+
+	// Replace button pressed
 	else if (esrc == update) {
-	    ElementWrapper element = tree.getSelectedMetadataElement();
-	    String value = tree.getSelectedValue();
-	    (new UpdateMetadataTask(element, value)).start();
-	    value = null;
-	    element = null;
-	}
+	    MetadataElement metadata_element = metadata_value_table.getSelectedMetadataElement();
+	    MetadataValueTreeNode metadata_value_tree_node = metadata_element.addMetadataValue(metadata_value_tree.getSelectedValue());
+	    MetadataValue metadata_value = new MetadataValue(metadata_element, metadata_value_tree_node);
+	    metadata_value.setIsAccumulatingMetadata(!metadata_value_table.getSelectedMetadataValueTableEntry().isInheritedMetadata());
+	    (new UpdateMetadataTask(metadata_value)).start();
+	}
+
+	// Remove button pressed
 	else if (esrc == remove) {
 	    (new RemoveMetadataTask()).start();
 	}
+
+	// Expand button pressed
 	else if (esrc == expand) {
 	    EditorDialog ed = new EditorDialog();
-	    String temp = ed.display(tree.getSelectedValue());
-	    if (temp != null) {
-		tree.setSelectedValue(temp);
-	    }
-	}
+	    String new_metadata_value = ed.display(metadata_value_tree.getSelectedValue());
+	    if (new_metadata_value != null) {
+		metadata_value_tree.setSelectedValue(new_metadata_value);
+	    }
+	}
+
+	// Expand button for extracted metadata pressed
 	else if (esrc == expand_for_extracted) {
 	    EditorDialog ed = new EditorDialog();
 	    ed.setEditable(false);
-	    String temp = ed.display(selected_metadata.getValue());
-	}
-	validateControls();
-    }
-
-    private class AppendMetadataTask
-	extends Thread {
-
-	private ElementWrapper element = null;
-	private String value = null;
-
-	private AppendMetadataTask(ElementWrapper element, String raw_value) {
-	    this.element = element;
-	    this.value = raw_value;
-	    // Transform the raw text to be GREENSTONE and DOM compatible - as that will be its next destination immediately after being added to the value model
-	    //this.value = /odec.transform(value, /odec.ENCODE_PATH);
-	    //this.value = /odec.transform(this.value, /odec.REMOVE_SQUARE_BRACKET);
-	    //this.value = /odec.transform(this.value, /odec.TEXT_TO_DOM);
-	}
-
-	public void run() {
-	    // System.err.println("Add metadata - '" + value + "'");
-	    // Check the new metadata is valid
-	    if (records != null && element != null && value != null) {
-		// Check the records, and if they are folders then display the warning.
-		Metadata added_metadata = null;
-		if (!records[0].isLeaf()) {
-		    WarningDialog dialog = new WarningDialog("warning.DirectoryLevelMetadata", true);
-		    if (dialog.display() == JOptionPane.OK_OPTION) {
-			added_metadata = Gatherer.c_man.getCollection().msm.addMetadata(System.currentTimeMillis(), records, element, value);
-		    }
-		    dialog.dispose();
-		    dialog = null;
-		}
-		else {
-		    added_metadata = Gatherer.c_man.getCollection().msm.addMetadata(System.currentTimeMillis(), records, element, value);
-		}
-		model.selectMetadataWhenBuildingComplete(added_metadata);
-	    }
-	}
-    }
-
-    private class UpdateMetadataTask
-	extends Thread {
-
-	private ElementWrapper element;
-	private String value;
-
-	private UpdateMetadataTask(ElementWrapper element, String raw_value) {
-	    this.element = element;
-	    this.value = raw_value;
-	    // Transform the raw text to be DOM compatible - as that will be its next destination immediately after being added to the value model
-	    //this.value = /odec.transform(value, /odec.REMOVE_SQUARE_BRACKET);
-	    //this.value = /odec.transform(this.value, /odec.TEXT_TO_DOM);
-	}
-
-	public void run() {
-	    // You can only update if there is a selected_metadata and
-	    // you have valid values in all fields.
-	    DebugStream.println("Replacing value:");
-	    if (selected_metadata != null && records != null && element != null && value != null) {
-		selected_metadata = Gatherer.c_man.getCollection().msm.updateMetadata(System.currentTimeMillis(), selected_metadata, records, value, MetaEditPrompt.CONFIRM, selected_metadata.isFileLevel());
-	    }
-	    model.selectMetadataWhenBuildingComplete(selected_metadata);
-	}
-    }
-
-    private class RemoveMetadataTask
-	extends Thread {
-
-	private RemoveMetadataTask() {}
-
-	public void run() {
-	    DebugStream.println("Removing value:");
-	    if (selected_metadata != null && records != null) {
-		Gatherer.c_man.getCollection().msm.removeMetadata(System.currentTimeMillis(), selected_metadata, records);
-	    }
-
-	    // Select the closest piece of metadata with the same element name
-	    model.selectClosestMetadataWhenBuildingComplete(selected_metadata);
-	}
-    }
+	    ed.display(metadata_value_table.getSelectedMetadataValueTableEntry().getFullValue());
+	}
+    }
+
 
     /** Some actions can only occur after this panel has been displayed on-screen, so this method is provided to do exactly that. Such actions include the proportioning of the split panes and the setting of table column widths.
-     * @see org.greenstone.gatherer.gui.table.GTableModel
      */
-    public void afterDisplay() {
+    public void afterDisplay()
+    {
 	external_split.setDividerLocation(0.3);
     }
+
+
     /** Called whenever a significant change has occured in the state of the currently loaded collection.
      * @param ready <i>true</i> if there is a collection currently ready to be editing, <i>false</i> otherwise.
@@ -312,30 +235,19 @@
      * @see org.greenstone.gatherer.util.TreeSynchronizer
      */
-    public void collectionChanged(boolean ready) {
+    public void collectionChanged(boolean ready)
+    {
 	if (ready) {
+	    // System.err.println("In collectionChanged(true).");
 	    TreeModel collection_model = Gatherer.c_man.getRecordSet();
-	    //String[] args = new String[1];
-	    //args[0] = Gatherer.c_man.getCollection().getName();
 	    Dictionary.registerText(collection_label, "Collection.Collection");
+
 	    // Update label coloring.
 	    collection_label.setBackground(Configuration.getColor("coloring.collection_heading_background", false));
 	    collection_label.setForeground(Configuration.getColor("coloring.collection_heading_foreground", false));
 	    collection_tree.setModel(collection_model);
+
 	    // Update tree coloring.
 	    collection_tree.setBackground(Configuration.getColor("coloring.collection_tree_background", false));
 	    collection_tree.setForeground(Configuration.getColor("coloring.collection_tree_foreground", false));
-	    // Register our msm dependant components (or correctly their models) with msm.
-	    if (model != null) {
-		// remove the listener first - in case its already present
-		Gatherer.c_man.getCollection().msm.removeMSMListener(model);
-		Gatherer.c_man.getCollection().msm.addMSMListener(model);
-	    }
-	    // register the pane itself as an MSMListener, so if we add a new metadata set, it will immediately show up. - remove itself first just in case
-	    Gatherer.c_man.getCollection().msm.removeMSMListener(this);
-	    Gatherer.c_man.getCollection().msm.addMSMListener(this);
-
-	    // Clear the currently selected metadata element in the table
-	    // This is important so the value tree is refreshed when the collection changes
-	    tree.setSelectedMetadataElement(null);
 	}
 	else {
@@ -350,4 +262,6 @@
 	tree_sync.add(collection_tree);
     }
+
+
     /** Used to create, connect and layout the components to be shown on this control panel.
      * @see org.greenstone.gatherer.Gatherer
@@ -355,9 +269,7 @@
      * @see org.greenstone.gatherer.file.FileOpenActionListener
      * @see org.greenstone.gatherer.gui.Filter
-     * @see org.greenstone.gatherer.gui.GComboBox
-     * @see org.greenstone.gatherer.gui.table.GTableModel
      */
-    public void display() {
-	RightButtonListener right_button_listener = new RightButtonListener();
+    public void display()
+    {
 	// Creation
 	JPanel collection_pane = new JPanel(new BorderLayout());
@@ -367,5 +279,4 @@
 	external_split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
 
-	///atherer.println("\tCreating collection_label");
 	collection_label = new JLabel();
 	Dictionary.registerText(collection_label, "Collection.No_Collection");
@@ -375,8 +286,8 @@
 	TreeModel collection_model = Gatherer.c_man.getRecordSet();
 	if (collection_model != null) {
-	    collection_tree = new DragTree("MetaEdit", collection_model, null, false);
+	    collection_tree = new DragTree("Enrich", collection_model, null, false);
 	}
 	else {
-	    collection_tree = new DragTree("MetaEdit", null, false);
+	    collection_tree = new DragTree("Enrich", null, false);
 	}
 	group.add(collection_tree);
@@ -384,10 +295,10 @@
 	collection_tree.putClientProperty("JTree.lineStyle", "Angled");
 	collection_tree.addMouseListener(Gatherer.g_man.foa_listener);
-	collection_tree.addMouseListener(right_button_listener);
+	collection_tree.addMouseListener(new RightButtonListener());
 	collection_tree.addTreeSelectionListener(this);
 	collection_tree.addTreeExpansionListener(Gatherer.g_man.foa_listener);
 	collection_tree.setLargeModel(true);
 	collection_tree.setRootVisible(false);
-	
+
 	KeyListenerImpl key_listener = new KeyListenerImpl();
 	collection_tree.addKeyListener(key_listener);
@@ -398,6 +309,4 @@
 	filter.setEditable(Configuration.getMode() > Configuration.LIBRARIAN_MODE);
 	Dictionary.registerTooltip(filter.getComboBox(), "Collection.Filter_Tooltip");
-
-	// Connection
 
 	// Layout
@@ -432,6 +341,4 @@
 	Dictionary.registerText(table_label, "MetaEdit.No_File");
 
-	card_layout = new CardLayout();
-
 	table_card_pane = new JPanel();
 
@@ -456,43 +363,29 @@
 	JPanel table_pane_one = new JPanel();
 
-	///atherer.println("\tCreating metadata_table");
-	table = new JTable();
-	model = new GTableModel(table);
-	table.setModel(model);
-	table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
-	table.getSelectionModel().addListSelectionListener(this);
-	table.setColumnSelectionAllowed(false);
-
-	// The default JTable doesn't quite have the desired properties - when a
-	// table cell is clicked on, the table is scrolled so the cell is as
-	// visible as possible. This means that the left-most cells can become
-	// hidden. To fix this, the MouseInputHandler in BasicTableUI is removed
-	// as a MouseListener on the table, and a very slightly altered copy is
-	// added in its place (TableMouseInputHandler).
-	MouseListener[] mls = table.getMouseListeners();
-	for (int i = 0; i < mls.length; i++) {
-	    // Remove the instances of MouseInputHandler
-	    if (mls[i].toString().startsWith("javax.swing.plaf.basic.BasicTableUI$MouseInputHandler@")) {
-		table.removeMouseListener(mls[i]);
-	    }
-	}
-	// Add the slightly-altered mouse listener
-	table.addMouseListener(new TableMouseInputHandler());
-
-	// We also have to ensure that the table column header hasn't gone on a severe Jenny Craig binge and has somehow lost 7/8th of its component size (15 -> 2 pixels high).
-	JTableHeader table_header = table.getTableHeader();
-	Dimension table_header_preferred_size = table_header.getPreferredSize();
-	if (table_header_preferred_size.height < MINIMUM_TABLE_HEADER_SIZE) {
-	    table_header_preferred_size.setSize(table_header_preferred_size.width, MINIMUM_TABLE_HEADER_SIZE);
-	    table_header.setPreferredSize(table_header_preferred_size);
-	}
-
-	JScrollPane table_scroll = new JScrollPane(table);
+	JScrollPane table_scroll = new JScrollPane(metadata_value_table);
 	table_scroll.getViewport().setBackground(Configuration.getColor("coloring.collection_tree_background", false));
 	table_scroll.setOpaque(true);
 
+	// Create the cards for the metadata value table
+	metadata_value_table_card_layout = new CardLayout();
+
+	table_pane_zero.setLayout(new BorderLayout());
+	table_pane_zero.add(no_file_message, BorderLayout.CENTER);
+
+	table_pane_one.setLayout(new BorderLayout());
+	table_pane_one.add(table_scroll, BorderLayout.CENTER);
+
+	table_pane_two.setLayout(new BorderLayout());
+	table_pane_two.add(no_metadata_message, BorderLayout.CENTER);
+
+	table_card_pane.setLayout(metadata_value_table_card_layout);
+	table_card_pane.add(table_pane_zero, TABLE_CARD_NO_FILES_SELECTED);
+	table_card_pane.add(table_pane_one, TABLE_CARD);
+	table_card_pane.add(table_pane_two, TABLE_CARD_NO_METADATA_AVAILABLE);
+
+	// Create the cards for the metadata value tree
+	metadata_value_tree_card_layout = new CardLayout();
+
 	// Control pane
-	///atherer.println("\tCreating Metadata Controls");
-
 	control_pane = new JPanel();
 	control_pane.setBorder(BorderFactory.createLoweredBevelBorder());
@@ -501,6 +394,4 @@
 	control_pane.setPreferredSize(CONTROL_SIZE);
 
-	card_layout2 = new CardLayout();
-
 	JPanel tools_off_pane = new JPanel();
 
@@ -523,9 +414,9 @@
 
 	tools_on_pane.setLayout(new BorderLayout());
-	tools_on_pane.add(tree, BorderLayout.CENTER);
-
-	control_pane.setLayout(card_layout2);
-	control_pane.add(tools_off_pane, TOOLS_OFF);
-	control_pane.add(tools_on_pane, TOOLS_ON);
+	tools_on_pane.add(metadata_value_tree, BorderLayout.CENTER);
+
+	control_pane.setLayout(metadata_value_tree_card_layout);
+	control_pane.add(tools_off_pane, TREE_CARD_NO_METADATA_ELEMENT_SELECTED);
+	control_pane.add(tools_on_pane, TREE_CARD);
 
 	// Table components
@@ -534,18 +425,4 @@
 	table_title_pane.add(table_label, BorderLayout.CENTER);
 
-	table_pane_zero.setLayout(new BorderLayout());
-	table_pane_zero.add(no_file_message, BorderLayout.CENTER);
-
-	table_pane_one.setLayout(new BorderLayout());
-	table_pane_one.add(table_scroll, BorderLayout.CENTER);
-
-	table_pane_two.setLayout(new BorderLayout());
-	table_pane_two.add(no_metadata_message, BorderLayout.CENTER);
-
-	table_card_pane.setLayout(card_layout);
-	table_card_pane.add(table_pane_zero, CARD_ZERO);
-	table_card_pane.add(table_pane_one, CARD_ONE);
-	table_card_pane.add(table_pane_two, CARD_TWO);
-
 	table_pane.setLayout(new BorderLayout());
 	table_pane.add(table_title_pane, BorderLayout.NORTH);
